/**************************************************************
 *
 * File: hw3a_soln.c
 * Author: Steve Wolfman
 *
 * Description: Sample solution to CSE142 01sp project #3A.
 * See http://www.cs.washington.edu/142/ (navigate to hw#3, 01sp) for
 * description of assignment.
 *
 **************************************************************/


/********* Useful constants **************/
#define BASE              36  /* The numerical base used for "words"
                                 in the program. */
#define WORD_NUM_SENTINEL -1  /* Value returned by getWordNum if a
                                 terminating word is read. (NOT AN
                                 ERROR CODE!) */


/********* Function prototypes ***********/
void printHeader(void);
/* Prints a decorative header.      */

void printFooter(void);
/* Prints a decorative footer.      */

int  getWordNum(void);
/* Reads a word, returns its value. */

char getDigit(void);
/* Reads and returns a digit.       */

int  isValidDigit(char digit);
/* Checks a digit against the BASE. */

int  addDigit(int currNum,        /* Given current word value, finds */
              char digit);        /* the value with digit tacked on.  */

int  getNumFromDigit(char digit); /* Gets numerical value of digit.   */

int  isPrime(int num);            /* Checks if num is prime.          */

int  isDivisibleBy(int num,       /* Checks if divisor divides num    */
                   int divisor);  /* evenly.                          */

void printAnswer(int bIsPrime);   /* Outputs correct message based    */
                                  /* on answer (prime or not).        */

/********* Main function *****************/
int main(void)
{

  /* TO BE IMPLEMENTED. */

  /* For now, let's test the isDivisibleBy function.  That way we can
     write just it without worrying about anything else. */
  int number, divisor;
  
  printf("Testing isDivisibleBy. Enter a number and a divisor: ");
  scanf("%d%d", &number, &divisor);
  printf("Result of isDivisibleBy is %d.\n",
         isDivisibleBy(number, divisor));
  
  return 0;
  
}


/*********************************************************************
 * printHeader:
 *   Prints a pretty header for the program.
 *
 *precondition: none
 *postcondition: printed header
 *********************************************************************/
void printHeader(void)
{

  /* TO BE IMPLEMENTED. */
}


/*********************************************************************
 * printFooter:
 *   Prints a pretty footer for the program.
 *
 *precondition: none
 *postcondition: printed footer
 *********************************************************************/
void printFooter(void)
{

  /* TO BE IMPLEMENTED. */
}



/*********************************************************************
 * printAnswer:
 *   Prints an appropriate message depending on the answer passed.
 *
 *     bIsPrime: holds whether the number was prime.
 *
 *precondition: bIsPrime is a Boolean (0 or 1)
 *postcondition: prints appropriate message for bIsPrime
 *********************************************************************/
void printAnswer(int bIsPrime)
{

  /* TO BE IMPLEMENTED. */
}


/*********************************************************************
 * getWordNum
 *   Reads a word from standard input and returns its base 36
 *   representation. If the word starts with a 0, immediately returns
 *   WORD_NUM_SENTINEL. Exits on malformed or overly large words.
 *
 *precondition: none
 *postcondition: returns numerical value of the next word,
 *               WORD_NUM_SENTINEL, or exits program as appropriate.
 *********************************************************************/
int  getWordNum(void)
{

  /* TO BE IMPLEMENTED. */
  return 0;
  
}


/*********************************************************************
 * getDigit
 *   Reads a digit from standard input and returns it. Exits on
 *   malformed digits.
 *
 *precondition: none
 *postcondition: returns a digit 0-9 or A-Z (depending on BASE) or \n.
 *********************************************************************/
char getDigit(void)
{

  /* TO BE IMPLEMENTED. */
  return 'X';
  
}


/*********************************************************************
 * isValidDigit:
 *   Checks whether the digit is valid in the current BASE.
 *
 *     digit: the digit to check
 *
 *precondition: none
 *postcondition: returns 1 if digit is valid, 0 otherwise
 *********************************************************************/
int isValidDigit(char digit)
{

  /* TO BE IMPLEMENTED. */
  return 0;
  
}


/*********************************************************************
 * addDigit:
 *   Starting with currNum, adds on digit as the next digit in the
 *   number. So, for example, in base two, currNum might be 10 (i.e.,
 *   1010 base two) and digit might be '1'. So, we shift currNum over
 *   (10100 base two is 20) and add the value of digit (1) to get 21.
 *   Returns the resulting value.
 *
 *     currNum: the number so far
 *     digit: the next digit
 *
 *precondition: currNum >= 0 and digit is valid in BASE
 *postcondition: returns correct value for currNum with digit appended
 *********************************************************************/
int addDigit(int currNum, char digit)
{

  /* TO BE IMPLEMENTED. */
  return 0;
  
}


/*********************************************************************
 * getNumFromDigit:
 *   Given a digit in BASE, returns its numerical value.
 *
 *     digit: the digit to translate
 *
 *precondition: digit is valid in BASE
 *postcondition: returns correct value for digit in BASE
 *********************************************************************/
int getNumFromDigit(char digit)
{

  /* TO BE IMPLEMENTED. */
  return 0;
  
}


/*********************************************************************
 * isPrime:
 *   Returns whether the given number is prime
 *
 *     num: the number to check for primality
 *
 *precondition: num > 0
 *postcondition: returns 1 if num is prime; otherwise, 0
 *********************************************************************/
int isPrime(int num)
{

  /* TO BE IMPLEMENTED. */
  return 0;
  
}


/*********************************************************************
 * isDivisibleBy:
 *   Returns whether num is divisible by divisor
 *
 *     num: the number to check for divisibility
 *     divisor: the number to check against
 *
 *precondition: num >= 0, divisor > 0
 *postcondition: returns 1 if num is divisible by divisor; else, 0
 *********************************************************************/
int isDivisibleBy(int num, int divisor)
{

  /* TO BE IMPLEMENTED. */
  return 0;
  
}


